=== debian/changelog ===
pyside2 (2.0.0+dev-0~201712030057~rev1789~pkg60~ubuntu17.04.1) zesty; urgency=low

  * Auto build.

 -- Thomas Karl Pietrowski <thopiekar@googlemail.com>  Sun, 03 Dec 2017 00:57:42 +0000
